/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.JSHelper.Logging;

import org.apache.log4j.Logger;

import com.sos.JSHelper.Exceptions.JobSchedulerException;

/**
 * \file MissingAppenderException.java
 * \brief Appender ist nicht in Konfigurationsfile vorhanden
 *  
 * \class MissingAppenderException 
 * \brief Appender ist nicht in Konfigurationsfile vorhanden
 * 
 * \details
 * Diese Exception wird ausgelst, wenn ein erwarteter Appender nicht im Konfigurationsfile
 * vorhanden ist.
 *
 * \author EQCPN
* @version $Id$13.05.2009 11:13:33
 *
 * <div class="sos_branding">
 *   <p> 2009 APL/Software GmbH - Berlin - generated by ClaviusXPress (<a style="color:silver" href="http://www.sos-berlin.com" target="_blank">http://www.sos-berlin.com</a>)</p>
 * </div>
 */
public class MissingAppenderException extends JobSchedulerException {
	
	@SuppressWarnings("unused")
	private static final String	conClassName		= "MissingAppenderException";
	private static final long	serialVersionUID	= 1L;
	private static Logger		logger				= Logger.getRootLogger();

	/*!
	 * @brief Construtor with message.
	 *
	 * @param msg the message-text of the exception
	 */
	public MissingAppenderException(String pstrMessage) {
		super(pstrMessage);
		this.Message(pstrMessage);
		this.Status(JobSchedulerException.PENDING);
		logger.error(this.ExceptionText());
		//        this.Category(CategoryOptions);
		//        this.Typ(TypeOptionMissing);
	}

	public MissingAppenderException() {
		this("exception 'MissingAppenderException' raised ...");
		logger.error(this.ExceptionText());
	}

	public String ExceptionText() {
		String strT = null;
		strT = super.ExceptionText();
		return strT;
	}
	
}
