/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.JSHelper.Options;


/**
* \class JSOptionIndexedItem 
* 
* \brief JSOptionIndexedItem - 
* 
* \details
*
* \section JSOptionIndexedItem.java_intro_sec Introduction
*
* \section JSOptionIndexedItem.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author EQALS
* @version $Id$19.10.2009
* \see reference
*
* Created on 19.10.2009 10:58:39
 */

public class JSOptionIndexedItem extends SOSOptionElement {

	private final String	conClassName	= "JSOptionIndexedItem";

	protected String[]		strValueList;
	private String			strIndexedKey	= null;

	/**
	 * 
	 * \brief JSOptionIndexedItem
	 *
	 * \details
	 *
	 * @param pPobjParent
	 * @param pPstrKey
	 * @param pPstrDescription
	 * @param pPstrValue
	 * @param pPstrDefaultValue
	 * @param pPflgIsMandatory
	 * @throws Exception 
	 */
	public JSOptionIndexedItem(JSOptionsClass pobjParent, String pstrKey, String pstrDescription, String pstrValue, String pstrDefaultValue,
			boolean pflgIsMandatory) {
		super(pobjParent, pstrKey, pstrDescription, pstrValue, pstrDefaultValue, pflgIsMandatory);
		strIndexedKey = pstrKey;
	}

	public JSOptionIndexedItem(JSOptionsClass pobjParent, String pstrIndexedKey, String pstrDescription, String pstrDefaultValue, boolean pflgIsMandatory)
			throws Exception {
		super(pobjParent, pstrIndexedKey, pstrDescription, null, pstrDefaultValue, pflgIsMandatory);

		strIndexedKey = pstrIndexedKey;
		IndexedKey();
	}

	private void IndexedKey()  {
		if (this.isEmpty(this.strIndexedKey) == false) {
			this.strValueList = objParentClass.getItems(this.strIndexedKey).toArray(new String[0]);
		}
		//		this.strValueList = objValueList.toArray(new String[0]);
		//		this.strValueList = new String[objValueList.size()];

	}

	@Override
	public void MapValue()  {
		IndexedKey();
	}

	/**
	 * 
	 * \brief value - liefert die ValueList als String-Array
	 * 
	 * \details
	 * Diese Methode liefert die ValueList als StringArray.
	 * 
	 * Ein Beispiel:
	 * \code
	 * 			for (int i = 0; i < objVL.value().length; i++) {
	 *				System.out.println (String.format("Index %1$d hat den Wert '%2$s'", i, objVL.ElementAt(i)));
	 *			}
	 * \endcode
	 * 
	 * \return String[] - die ValueList oder eine Liste mit einem leeren Element
	 *
	 * @return
	 */
	public String[] value() {

		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::value";

		if (this.strValueList == null) {
			this.strValueList = new String[] {  };
		}

		return strValueList;
	} // public String[] value}

	/**
	 * 
	 * \brief AppendValue
	 * 
	 * \details
	 *
	 * \return void
	 *
	 * @param pstrValueList
	 * @throws Exception 
	 */
	public void AddItem(String pstrValue) throws Exception {
//		String strT = pstrValue;

		if (isNotEmpty(pstrValue)) {
			if (this.strValueList == null) {
				this.strValueList = new String[] {};
				super.strValue = pstrValue;
			}
			int intLengthActual = this.strValueList.length;
			String[] strNew = new String[intLengthActual + 1];
			System.arraycopy(strValueList, 0, strNew, 0, intLengthActual);
			strNew[intLengthActual] = pstrValue;
			this.strValueList = strNew;
			//			super.strValue += ";" + pstrValue.replace(";", "");
		}
	}

	@Override
	public boolean IsEmpty() {
		return (this.strValueList == null || this.strValueList.length <= 0);
	}

	/**
	 * 
	 * \brief concatenatedValue
	 * 
	 * \details
	 *
	 * \return String
	 *
	 * @param pstrDelimiter
	 * @return
	 */
	public String concatenatedValue(String pstrDelimiter) {
		StringBuffer strB = new StringBuffer();
		String strT = "";

		if (this.strValueList == null) {
			return strT;
		}
		for (int i = 0; i < this.strValueList.length; i++) {
			strT = this.strValueList[i];
			if (i > 0) {
				if (!this.strValueList[i - 1].trim().endsWith(pstrDelimiter)) {
					strB.append(pstrDelimiter);
				}
			}
			strB.append(strT);
		}
		return strB.toString();
	}

}
