/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.localization;

import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
* \class Messages 
* 
* \brief Messages - 
* 
* \details
*
* \section Messages.java_intro_sec Introduction
*
* \section Messages.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author KB
* @version $Id$03.09.2010
* \see reference
*
* Created on 03.09.2010 13:10:49
 */

public class Messages {
	private static final String		BUNDLE_NAME		= "com.sos.localization.messages";	//$NON-NLS-1$

	private static ResourceBundle	RESOURCE_BUNDLE	= null;

	private Messages() {
	}

	private static String getString(final String pstrKey, ResourceBundle objBundle) {
		try {
			String strM = "";
			if (RESOURCE_BUNDLE == null) {
				RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME);
			}
			if (RESOURCE_BUNDLE != null) {
				strM = RESOURCE_BUNDLE.getString(pstrKey);
				if (strM.startsWith("[") && strM.endsWith("]")) { //$NON-NLS-1$
					strM = getString(strM.substring(1, strM.length() - 1), objBundle);
				}
			}
			else {
				strM = pstrKey;
			}
			return strM;
		}
		catch (MissingResourceException e) {
			// TODO check who is the caller of this missing key and put his name into the string
			return '!' + pstrKey + '!'; //$NON-NLS-1$
		}

	}

	/**
	 * 
	 * \brief getMsg
	 * 
	 * \details
	 *
	 * \return String
	 *
	 * @param pstrKey
	 * @return
	 */
	public static String getMsg(final String pstrKey) {
		try {
			String strM = getString(pstrKey, RESOURCE_BUNDLE);
			strM = pstrKey + ": " + strM;
			return strM;
		}
		catch (MissingResourceException e) {
			return '!' + pstrKey + '!';
		}
	}

	/**
	 * 
	 * \brief getMsg
	 * 
	 * \details
	 *
	 * \return String
	 *
	 * @param pstrKey
	 * @param pobjLocale
	 * @return
	 */
	public static String getMsg(final String pstrKey, Locale pobjLocale) {
		try {
			ResourceBundle objBundle = ResourceBundle.getBundle(BUNDLE_NAME, pobjLocale);
			String strM = getString(pstrKey, objBundle);
			strM = pstrKey + ": " + strM;
			return strM;
		}
		catch (MissingResourceException e) {
			return '!' + pstrKey + '!';
		}
	}

}
