/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.model.objects;

import org.apache.log4j.Logger;

import com.sos.VirtualFileSystem.Interfaces.ISOSVirtualFile;
import com.sos.scheduler.model.SchedulerObjectFactory;



/**
* \class JSObjJobChain 
* 
* \brief JSObjJobChain - 
* 
* \details
*
* \section JSObjJobChain.java_intro_sec Introduction
*
* \section JSObjJobChain.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$
* \see reference
*
* Created on 09.02.2011 14:37:58
 */

/**
 * @author oh
 *
 */

public class JSObjJobChain extends JobChain {

	private final String		conClassName	= "JSObjJobChain";
	@SuppressWarnings("unused")
	private static final Logger	logger			= Logger.getLogger(JSObjJobChain.class);
	
	public final static String fileNameExtension = ".job_chain.xml";

	public JSObjJobChain(SchedulerObjectFactory schedulerObjectFactory) {
		objFactory = schedulerObjectFactory;
	}
	
	public JSObjJobChain (SchedulerObjectFactory schedulerObjectFactory, JobChain origOrder) {
		objFactory = schedulerObjectFactory;
		setObjectFieldsFrom(origOrder);
	}
	
	public JSObjJobChain(SchedulerObjectFactory schedulerObjectFactory, ISOSVirtualFile pobjVirtualFile) {
		objFactory = schedulerObjectFactory;
		JobChain objJobChain = (JobChain) unMarshal(pobjVirtualFile);
		setObjectFieldsFrom(objJobChain);
		setHotFolderSrc(pobjVirtualFile);
	}
	
	
	/**
	 * 
	 * \brief setOrdersRecoverable
	 * 
	 * \details
	 *
	 * \return void
	 *
	 * @param pflgIsOrdersRecoverable
	 */
	public void setOrdersRecoverable(final boolean pflgIsOrdersRecoverable) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setOrdersRecoverable";
		if (pflgIsOrdersRecoverable == true) {
			this.setOrdersRecoverable("yes");
		}
		else {
			this.setOrdersRecoverable("no");
		}
    } // public void setOrdersRecoverable
	
	
	/**
	 * 
	 * \brief setVisible
	 * 
	 * \details
	 *
	 * \return void
	 *
	 * @param pflgIsVisible
	 */
	public void setVisible(final boolean pflgIsVisible) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setVisible";
		if (pflgIsVisible == true) {
			this.setVisible("yes");
		}
		else {
			this.setVisible("no");
		}
	} // public void setVisible
	
	/**
	 * 
	 * \brief setDistributed
	 * 
	 * \details
	 *
	 * \return void
	 *
	 * @param pflgIsDistributed
	 */
	public void setDistributed(final boolean pflgIsDistributed) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setDistributed";
		if (pflgIsDistributed == true) {
			this.setDistributed("yes");
		}
		else {
			this.setDistributed("no");
		}
	} // public void setDistributed

	
	
}
