/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package sos.stresstest;

/**
 * @author Andreas Pschel <andreas.pueschel@sos-berlin.com>
 * @since 2004-11-21
 * @version 1.1
 * 
 * 
 * StresstestSession kann als abstrakte Klasse nicht instanziiert werden, jedoch kann der StresstestThread
 * von ihr erbende nicht abstrakte Klassen instanziieren. Dadurch ist es mglich nachtrglich 
 * Java-Klassen zu schreiben auf die der StresstestThread ber den Klassennamen zugreifen kann
 *  ohne das im StresstestThread, StresstestSession und SOSStresstestSession verndert werden muss.
 * 
 */
public class StresstestResponse {

	
	/** Attribut: responseCode: Rckgabewert (0=ok, 1=Fehler etc.) */
	int responseCode = 0;
	
	/** Attribut: responseMessage: Nachricht */
	String responseMessage = new String("");
	
	
	public StresstestResponse() {
	}
	
	public StresstestResponse( int responseCode) {

		this.setResponseMessage(responseMessage);
	}
	
	public StresstestResponse( int responseCode, String responseMessage) {

		this.setResponseCode(responseCode);
		this.setResponseMessage(responseMessage);
	}
	

	/**
	 * @return Returns the responseCode.
	 */
	public int getResponseCode() {
		return responseCode;
	}
	
	/**
	 * @return Returns the responseCode.
	 */
	public int get_response_code() {
		return responseCode;
	}
	
	/**
	 * @param responseCode The responseCode to set.
	 */
	protected void setResponseCode(int responseCode) {
		this.responseCode = responseCode;
	}
	
	/**
	 * @return Returns the responseMessage.
	 */
	public String getResponseMessage() {
		return responseMessage;
	}
	
	/**
	 * @return Returns the responseMessage.
	 */
	public String get_response_message() {
		return responseMessage;
	}
	
	/**
	 * @param responseMessage The responseMessage to set.
	 */
	protected void setResponseMessage(String responseMessage) {
		this.responseMessage = responseMessage;
	}
}
