/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package sos.stresstest.dialogtest;

/* 
 * Created on 09.12.2004
 */ 

import java.util.ArrayList;
import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

import sos.util.SOSClassUtil;

/**
 * @author ur
 * 
 * To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public class DialogTester extends DialogTesterBasic {
		
    //private ArrayList listOfDialogTakes;       // Enthlt die Takes des Recordings

    private NodeList nodesTakes=null;
    //private NodeList nodesSteps=null;
    
    private boolean printRequest = false;
    private boolean printHeader = false;
    private boolean showHtml = false;
    private boolean showStep = false;
    private boolean copyHtmlToFile = false;
    private boolean enableChecks=false;

    private ArrayList tagValues=null;
    private ArrayList htmlCheckValues=null;
    private boolean list;
    private boolean session_clear=false;
		
    private String sessionID = null;
		private String sessionIDKey = null;
		private boolean sessionIDReplaces = false;
		
		private String url_search = null;
		private String url_replace = null;
		private boolean url_replaced = false;
		
    private ArrayList executeTakes=null;       // Enthlt die zur Ausfhrung kommenden Takes
    
    private String path = "";
    private Object checkClassObject=null;
    
    // die Nummer des Recordings
    private int nr = 0;
    
    private long step_counter = 0;
    
    private HashMap globalVars = null;
		
    protected XMLReport xmlReport = null;
    
    /**
     *Ein Objekt der Klasse Dialogtester fhrt Takes in einem Recording aus. 
     *Ein Recording besteht aus einer XML-Datei mit n Takes.
     *Das Recording kann mit der Anwendung <i>http://dod/dod/sos_recorder_dialog.php</i> erstellt werden
     */
    public DialogTester() {  
				
        tagValues = new ArrayList();
        executeTakes = new ArrayList();
        htmlCheckValues = new ArrayList();
        enableChecks=true;
        session_clear = false;
        setLogFile("");
    }
		
    public String getLog(){
        return "";
    }
    
    private void readTakes(String fileName) throws Exception {
    	
    	try {
            DocumentBuilderFactory docRecording;
            DocumentBuilder docBuild;
            Document doc = null;
            docRecording = DocumentBuilderFactory.newInstance();
            docBuild = docRecording.newDocumentBuilder();

            doc = docBuild.parse(fileName);

            nodesTakes = doc.getElementsByTagName("take");

        } catch (Exception e) {
        	String err_msg = "";
    			if (this.getDebugLevel()>2)
    				err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
      		throw new Exception(err_msg + e.toString());
        }
    }
		
	/** Fhrt die Takes in einem Recording aus. Es werden alle Takes ausgefhrt, wenn keine Einschrnkungen
	 * gemacht wurden. Einschrnkungen knnen mit addTake("name") gemacht werden. Es werden dann nur die angegebenen
	 * Takes ausgefhrt.
	 * @param f Der Name der Datei, die das Recording enthlt.
	 * @throws Exception
	 * @return Liefert einen Exitvalue zurck:<br>0 bei Erfolg<br>-1 wenn Fehler aufgetreten sind 
	 */
	public int executeDialog(String f) throws Exception {
		
		int i = 0;
		boolean recordingOk = true;
		DialogTake take=null;
		String checksEnabled;
		String takeName;
		
		try {
			
			init();
			log_info("Execute Dialog Begin");
			
			readTakes(f);		//Liest XML und liefert eine Nodelist mit den Takes
			
			if (nodesTakes.getLength() == 1)
				log_info("-Having one Take");
			else
				log_info("-Having " + nodesTakes.getLength() + " Takes");
			
			if (executeTakes.size() == 0) {
				
				log_info("-Performing all Takes");
			} else {
				
				log_info("-Performing Takes:" );
				for (int j=0;j< executeTakes.size();j++) {
					log_info("  ---> " + executeTakes.get(j) );
				}
			}
			
			for (i = 0;i< nodesTakes.getLength();i++) {
				
				takeName = nodesTakes.item(i).getAttributes().getNamedItem("name").getNodeValue();
				
				if (executeTakes.size() == 0 || executeTakes.indexOf(takeName) >= 0) {
					
					if ( this.xmlReport!=null ) this.xmlReport.resultOpenTake(takeName);
					
					take = new DialogTake(sosLogger,takeName);
	           		
					take.setNode(nodesTakes.item(i));
					take.setCaller(this);
					
					if ( ! take.execute() ) {
						
						log_info("\n");
						log_warn("Take " + take.getName() + " terminated with errors!");
						recordingOk = false;
					}
					
					if ( this.xmlReport!=null ) this.xmlReport.resultCloseTake();
				}
			}
			
			log_info("\n");
			
			for (i = 0; i < getHtmlCheckValues().size(); i++) {
				
				DialogTesterChecks check=(DialogTesterChecks) getHtmlCheckValues().get(i);
				if (!check.isUsed()){
					log_warn(" --> Check at take: \"" + check.getDialogTake() + "\", checkpoint: \"" + check.getDialogCheckpoint() + "\": \"" + check.getSearchString() + "\" was defined but not used!");
				}
			}
			
			if (this.enableChecks)
				checksEnabled = "";
			else
				checksEnabled = "(Checks has been disabled)";
			
			if ( this.sessionIDKey != null && !this.isSessionIDReplaces() ) {
				this.log_warn("sessionid_key \""+this.sessionIDKey+"\" was defined but not found");
			}
			
			if ( this.url_search!=null && !this.url_replaced ) {
				this.log_warn("url_search \""+this.url_search+"\" was defined but not found");
			}
		
		} catch (Exception e) {
			String err_msg = "";
			if (this.getDebugLevel()>2)
				err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
  		throw new Exception(err_msg + e.getMessage());
		
		} finally {
			
			if ( this.xmlReport!=null ) 
				if ( this.xmlReport.resultIsTakeOpen() )
					this.xmlReport.resultCloseTake();
		}
		
		if ( recordingOk ) {
			
			log_info("  ---   test successfully terminated   " + checksEnabled + "---   ");
			return 0;
		} else {
			
			log_info("  ---   test terminated with errors!   " + checksEnabled + "---   ");
			return -1;
		}
	}
	
	
	/**
	 * Listet die auszufhrenden Takes aus ohne sie auszufhren.
	 * @param f Der Name der Datei, die das Recording enthlt.
	 * @throws Exception
	 */
	public void list(String f) throws Exception {
		
		int i = 0;
		DialogTake take=null;
		String takeName;
		
		enableChecks = false;
		printRequest = false;
		printHeader = false;
		showHtml = false;
		showStep = false;
		copyHtmlToFile = false;
		enableChecks=false;
		
		try {
			
			init();        
			log_info("   ---    " + f + "    ---");
			
			readTakes(f); //Liest XML und liefert eine Nodelist mit den Takes
			
			if (nodesTakes.getLength() == 1)
				log_info("-Having one Take");
			else
				log_info("-Having " + nodesTakes.getLength() + " Takes");
			
			if (executeTakes.size() == 0) {
				
				log_info("-Performing all Takes");
			} else {
				
				log_info("-Performing Takes:" );
				for (int j=0;j< executeTakes.size();j++) {
					log_info("  ---> " + executeTakes.get(j) );
				}
			}
			
			for (i = 0;i< nodesTakes.getLength();i++) {
				
				takeName = nodesTakes.item(i).getAttributes().getNamedItem("name").getNodeValue();
				
				if (executeTakes.size() == 0 || executeTakes.indexOf(takeName) >= 0) {
					
					take = new DialogTake(sosLogger,takeName);
					take.setNode(nodesTakes.item(i));
					take.setCaller(this);
					list = true;
					take.execute();
				}
			}
			
		} catch (Exception e) {
			String err_msg = "";
			if (this.getDebugLevel()>2)
				err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
  		throw new Exception(err_msg + e.getMessage());
		}
	}
	
	/**
	 * Setzt   printRequest = true, printHeader = true, showHtml = true, showStep = true
	 */
	public void showAll() {
		
		printRequest = true;
		printHeader = true;
		showHtml = true;
		showStep = true;
	}

    /**
     * @param copyHtmlToFile 
     * 
     * True: Die Ausgaben pro Step werden in einer Datei ausgegeben. Die Datei liegt im
     * Verzeichnis path. Der Name der Datei wird nach dem Schema take_checkpoint_step.html aufgebaut
     * <br>Default=false;
     * @see 
     * DialogTester#setPath
     */
    public void setCopyHtmlToFile(boolean copyHtmlToFile) {
        this.copyHtmlToFile = copyHtmlToFile;
    }

    /**
     * @param printHeader
     * True: Der Header pro Step wird whrend des Ablaufs gezeigt.
     * 
     * <br>Default=false;     */
    public void setPrintHeader(boolean printHeader) {
        this.printHeader = printHeader;
    }

    /**
     * @param printRequest
     * True: Der Request pro Step wird whrend des Ablaufs gezeigt.
     * 
     * <br>Default=false
     */
    public void setPrintRequest(boolean printRequest) {
        this.printRequest = printRequest;
    }

    /**
     * @param showHtml
     * True: Die Ausgabe pro Step wird nach StdOut geschrieben
     * 
     * <br>Default=false
     */
    public void setShowHtml(boolean showHtml) {
        this.showHtml = showHtml;
    }

    /**
     * @param showStep
     * True: Vor jedem Step wird die Url, die Nummer des Steps und eine Linie ausgegeben
     * 
     * <br>Default=false 
     */
    public void setShowStep(boolean showStep) {
        this.showStep = showStep;
    }

    /**
     * @param path
     * Der Name des Pfads fr die Ausgabe der HTML-Datei
     */
    public void setPath(String path) {
        this.path = path;
    }

	/**
	 * Ab einem Checkpoint einen festen Wert verwenden
	 * @param tag Der Name des Tags
	 * @param take Der Name des Takes
	 * @param checkpoint_start Der Name des Checkpoints ab dem der Tag gendert werden soll.
	 * @param value Der Neue Wert
	 */
	public void setTagValue(String tag,String take,String checkpoint_start, String value) throws Exception {
		
		try {
			
			DialogTesterTags tv = new DialogTesterTags(tag, "", value, take, checkpoint_start, "");
			tv.setDebugLevel(this.getDebugLevel());
			tagValues.add(tv);
			
		} catch (Exception e) {
			String err_msg = "";
			if (this.getDebugLevel()>2)
				err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
  		throw new Exception(err_msg + e.getMessage());
		}
	}
	
/*
	/**
	 * Verwendet in einem bestimmten Checkpoint-Bereich einen festen Wert fr einen Tag.
	 * @param tag Der Name des Tags
	 * @param take Der Name des Takes
	 * @param checkpoint_start Der Name des Checkpoints ab dem der Tag gendert werden soll.
	 * @param checkpoint_stop Der Name des Checkpoints bis dem der Tag gendert werden soll.
	 * @param value Der Neue Wert
	 *
	private void setTagValue(String tag,String take,String checkpoint_start, String checkpoint_stop, String value) throws Exception {
		
		try {
			
			DialogTesterTags tv = new DialogTesterTags(tag, "",value, take, checkpoint_start, checkpoint_stop);
			tagValues.add(tv);
			
		} catch (Exception e) {
			String err_msg = "error in "+SOSClassUtil.getMethodName()+": "+e.getMessage();
			throw new Exception("\n"+err_msg);
		}
	}
*/
	
	/**
	 * Auszufhrende Takes festlegen. Ist die Liste leer, werden alle Takes ausgefhrt
	 * Die Takes werden in der Reihenfolge ausgefhrt, in der sie aufgezeichnet wurden    
	 * @param t Der Name des Takes. 
	 */
	public void addTake(String t) throws Exception {
		
		try {
			
			executeTakes.add(t);
			
		} catch (Exception e) {
			String err_msg = "";
			if (this.getDebugLevel()>2)
				err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
  		throw new Exception(err_msg + e.getMessage());
		}
	}
	
	/**
	 * ndert ab einem bestimmten Checkpoint den Wert eines Tags. Es knnen beliebig viele Tags gendert werden.
	 * @param tag Der Name des Tags
	 * @param take Der Name des Takes
	 * @param checkpoint_start Der Name des Checkpoints ab dem der Tag gendert werden soll.
	 * @param o
	 * @param v Neuer Wert
	 */	
	public void changeTagValue(String tag, String take, String checkpoint_start, String o, String v) throws Exception {
		
		try {
			
			DialogTesterTags tv = new DialogTesterTags(tag, o, v, take, checkpoint_start, "");
			tv.setDebugLevel(this.getDebugLevel());
			tagValues.add(tv);
			
		} catch (Exception e) {
			String err_msg = "";
			if (this.getDebugLevel()>2)
				err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
  		throw new Exception(err_msg + e.getMessage());
		}
	}    
	
//  von-bis  einen festen Wert verwenden
/*
	/**
	 * ndert in einem bestimmten Checkpoint-Bereich den Wert eines Tags. Es knnen beliebig viele Tags gendert werden.
	 * @param tag
	 * @param take
	 * @param checkpoint_start
	 * @param checkpoint_stop
	 * @param o Alter Wert
	 * @param v Neuer Wert
	 *
	private void changeTagValue(String tag, String take, String checkpoint_start, String checkpoint_stop,String o,String v) throws Exception {
		
		try {
			
			DialogTesterTags tv = new DialogTesterTags(tag, o, v, take, checkpoint_start, checkpoint_stop);
			tagValues.add(tv);
			
		} catch (Exception e) {
			String err_msg = "error in "+SOSClassUtil.getMethodName()+": "+e.getMessage();
			throw new Exception("\n"+err_msg);
		}
	}
*/
	
	/** 
	 * Fgt einen HTML-Ausgabestromtest hinzu. Der Test besteht aus einer Zeichenfolge, die in einem Checkpoint gesucht
	 * wird. Wenn sie gefunden wird ( in einem beliebigen Step des Checkpoints ), ist der Test bestanden.
	 * @param t Suchen im Take
	 * @param d Checkpoint
	 * @param s Suchstring
	 */
	public void checkHtml(String t,String d,String s) throws Exception {
		
		try {
			
			if (enableChecks) {
				
				DialogTesterChecks hc = new DialogTesterChecks(t,d,s);
				htmlCheckValues.add(hc);
			}
			
		} catch (Exception e) {
			String err_msg = "";
			if (this.getDebugLevel()>2)
				err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
  		throw new Exception(err_msg + e.getMessage());
		}
	}
	
	/** 
	 * Fgt einen HTML-Ausgabestromtest hinzu. Der Test besteht aus einer Zeichenfolge, die in einem Checkpoint gesucht
	 * wird. Wenn sie gefunden wird ( in einem beliebigen Step des Checkpoints ), ist der Test nicht bestanden.
	 * @param t Suchen im Take
	 * @param d Checkpoint
	 * @param s Suchstring
	 */
	public void checkHtmlAbsent(String t,String d,String s) throws Exception {
		
		try {
			
			if (enableChecks) { 
				DialogTesterChecks hc = new DialogTesterChecks(t,d,s);
				hc.setTrueIfExists(false);
				htmlCheckValues.add(hc);
			}
			
		} catch (Exception e) {
			String err_msg = "";
			if (this.getDebugLevel()>2)
				err_msg = "\nerror in "+SOSClassUtil.getMethodName()+": ";
  		throw new Exception(err_msg + e.getMessage());
		}
	}
	
    /**
     * Setzt den Namen der Klasse, die die Checkermethoden enthlt. Die Klasse muss von  <i>DialogTesterBasic</i> erben.
     * ( extends DialogTesterBasic )
     * Die Methoden werden via Reflection gerufen
     * Die Methoden folgen dem Namensschema take_checkpoint_pre|post() und liefern einen String
     * Wenn die Methode einen Leerstring liefert, ist der Test bestanden.
     * <br><u>
     * Beispiel:</u>
     * <pre>
     *  public String login_start_post() {
     *   log_info("Now in login_start_post");
     *   return "";
     * }</pre>
     * 
     * Der Konstrukur der  Klasse bekommt als Parameter die aktuelle Connection
     *  <pre> public DialogTesterCheckpoints(SOSConnection conn_) {
     *   conn = conn_;
     *  }</pre>
     *
     * Damit Logausgaben in das aktuelle Logfile geschrieben werden, muss der Logger gesetzt werden. Die Klasse 
     * muss dafr diese Methode beinhalten. Sie wird automatisch gerufen.
     * <br>
     * <pre>public void setSosLogger(SOSStandardLogger sosLogger) {
     *   this.sosLogger = sosLogger;
     * }</pre>

     * @param c Klasse mit den Checkmethoden
     */
    public void setCheckObject(Object c){
        if (enableChecks){
          checkClassObject = c;
        }
    }
    
    protected boolean isShowHtml() {
        return showHtml;
    }
    protected boolean isShowStep() {
        return showStep;
    }
    protected boolean isPrintHeader() {
        return printHeader;
    }
    protected boolean isPrintRequest() {
        return printRequest;
    }
    protected boolean isCopyHtmlToFile() {
        return copyHtmlToFile;
    }
    protected String getPath() {
        return path;
    }
    protected Object getCheckClassObject() {
        return checkClassObject;
    }
    protected ArrayList getHtmlCheckValues() {
        return htmlCheckValues;
    }
    protected ArrayList getTagValues() {
        return tagValues;
    }
    public void setEnableChecks(boolean enableChecks) {
        this.enableChecks = enableChecks;
    }
    protected boolean isEnableChecks() {
        return enableChecks;
    }    
    protected boolean isList() {
        return list;
    }
    protected boolean isSession_clear() {
        return session_clear;
    }
    protected void setSession_clear(boolean session_clear) {
        this.session_clear = session_clear;
    }
    
/*
    public static void main(String[] args) throws Exception {
    
        DialogTester x = new DialogTester();
        x.setLogFile("c:/1.log");
        x.init("c:/temp/inifile.ini");
        
        

        x.setDebugLevel(0);
        x.setPath("z:/dod/");
        //   x.showAll();
        x.setShowHtml(false);

        x.setEnableChecks(true);
        x.setPrintRequest(false);
        x.setPrintHeader(false);
        x.setCopyHtmlToFile(true);  // Html-Datei pro Dialogschritt erzeugen
        x.setShowStep(false);          // Pro Dialogschritt eine Log-Ausgabe 
        
        DialogTesterCheckpoints d = new DialogTesterCheckpoints(x.conn);
        
        x.setCheckObject(d);
       
        //x.addTake("login");
        //x.addTake("prioritaet aendern");

//        
        //Ab Checkpoint 'Check1' im Take 'bestellung bearbeiten' diese Order-Id verwenden
        x.setTagValue("order_lending","bestellung bearbeiten","Check1","ssssstest");
        
        //Ab Checkpoint 'start' im Take 'bestellung bearbeiten' die Order-Id x nach y verndern
       // x.changeTagValue("order_id","bestellung bearbeiten","system","SUBITO:D200411150227","SUBITO:D200411150228");
        
        // Tag in einem Bereich von Dialogschritten ndern
       // x.setTagValue("order_id","bestellung bearbeiten","system","start","SUBITO:D200411150227");
       // x.changeTagValue("order_id","bestellung_bearbeiten","system","start","SUBITO:D200411150227","SUBITO:D200411150228");
        
        // In der Ausgabe des Dialogschrittes 5 mu <body> enthalten sein. 
        x.checkHtml("system","system","Anfang");
        x.checkHtml("Login","Start","Anfang");
        x.checkHtmlAbsent("Login","Start","Anfang2");
//        x.checkHtml("Login","start","asdasd");
//        x.checkHtml("Login","start","ttteeesssttt");
      //  x.checkHtml("system","testfestrestbest");
      //  x.list("c:/1.xml");
       x.executeDialog("c:/2.xml");
    }
*/
		protected String getSessionID() {
			return sessionID;
		}

		protected void setSessionID(String sessionID) {
			this.sessionID = sessionID;
		}

		protected String getSessionIDKey() {
			return sessionIDKey;
		}

		protected void setSessionIDKey(String sessionIDKey) {
			this.sessionIDKey = sessionIDKey;
		}

		protected boolean isSessionIDReplaces() {
			return sessionIDReplaces;
		}

		protected void setSessionIDReplaces(boolean sessionIDReplaces) {
			this.sessionIDReplaces = sessionIDReplaces;
		}
		
		protected long get_next_stepc() {
			return ++this.step_counter;
		}
		
		protected long get_current_stepc() {
			return this.step_counter;
		}

		protected HashMap getGlobalVars() {
			return globalVars;
		}

		protected void setGlobalVars(HashMap globalVars) {
			this.globalVars = globalVars;
		}

		protected String getURL_replace() {
			return url_replace;
		}

		protected void setURL_replace(String url_replace) {
			this.url_replace = url_replace;
		}

		protected String getURL_search() {
			return url_search;
		}

		protected void setURL_search(String url_search) {
			this.url_search = url_search;
		}

		protected boolean isURL_replaced() {
			return this.url_replaced;
		}

		protected void setURL_replaced(boolean _url_replaced) {
			this.url_replaced = _url_replaced;
		}

		protected int getNr() {
			return nr;
		}

		protected void setNr(int nr) {
			this.nr = nr;
		}

		/**
		 * @param xmlReport The xmlReport to set.
		 */
		protected void setXmlReport(XMLReport xmlReport) {
		
			this.xmlReport = xmlReport;
		}

}
