/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: sosalloc.cxx 6235 2010-08-18 11:12:52Z jz $

#include "precomp.h"
#include "../kram/sysdep.h"

#include <stdlib.h>
#include <limits.h>             // UINT_MAX
#include <malloc.h>

#include "../zschimmer/zschimmer.h"
#include "../kram/sos.h"
#include "../kram/sosprof.h"
#include "../kram/log.h"
#include "../kram/sosalloc.h"

using namespace std;
namespace sos {

//------------------------------------------------------------------------------------sos_alloc

void* sos_alloc( int4 size, const char* info )
{
    void* p = zschimmer::z_malloc(size, info, 0);
    if( !p )  throw_no_memory_error( size );

    memset( p, 0, size );
    return p;
}

//-------------------------------------------------------------------------------------sos_free

void sos_free( void* ptr )
{
    return zschimmer::z_free( ptr );
}


} //namespace sos
