/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// sosfact.h                                             1995 SOS GmbH Berlin

#ifndef __SOSFACT_H
#define __SOSFACT_H

#include "soslist.h"
#include "sosobj.h"

namespace sos
{

struct File_spec;

//-----------------------------------------------------------------------------Sos_object_descr

struct Sos_object_descr
{
    typedef int                 Subtype_code;

                                Sos_object_descr        ();

    virtual const char*         name                    () const = 0;
    virtual Subtype_code        is_my_name              ( const char* n ) const { return strcmp( n, name() ) == 0? 1 : 0; }
    virtual Bool                handles_complete_name   () const                { return false; }
    virtual Sos_object_ptr      create                  ( Subtype_code ) const = 0;
};

//------------------------------------------------------------------------Sos_object_descr_node

typedef Sos_simple_list_node<const Sos_object_descr*>  Sos_object_descr_node;

//---------------------------------------------------------------------------------------static

struct Sos_factory : Sos_object
{
    BASE_CLASS( Sos_object )

                                Sos_factory         ()  { _obj_request_semaphore = 999; }
                               ~Sos_factory         ();  //jz 4.2.01

    void                        add                 ( const Sos_object_descr* );
    Sos_object_ptr              request_create      ( Sos_object* sender, const Sos_string& name, Sos_object* owner = 0 );
    Sos_object_ptr              create              ( const Sos_string& name, Sos_object* owner = 0 );

  protected:
  //void                       _obj_create_msg      ( Create_msg* );
#if !defined SYSTEM_RTTI
    void                       _obj_print           ( std::ostream* s ) const  { *s << "Sos_factory"; }
#endif

  private:
    friend struct               Sos_factory_agent;

    Sos_object_descr_node*     _object_descr_head;
};

//---------------------------------------------------------------------------------------extern

extern Sos_factory* sos_factory_ptr();       


} //namespace sos

#endif
