/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: spooler_xslt_stylesheet.h 5418 2007-12-06 14:13:38Z jz $

#ifndef __SPOOLER_XSLT_STYLESHEET_H
#define __SPOOLER_XSLT_STYLESHEET_H

#include "../zschimmer/xslt_libxslt.h"


namespace sos {
namespace scheduler {

//----------------------------------------------------------------------------------Xslt_stylesheet

struct Xslt_stylesheet : idispatch_implementation< Xslt_stylesheet, spooler_com::Ixslt_stylesheet >, 
                         xml::Xslt_stylesheet,
                         spooler_com::Ihas_java_class_name
{
    static Class_descriptor        class_descriptor;
    static const com::Com_method  _methods[];


                                Xslt_stylesheet             ();
                              //Xslt_stylesheet             ( const string& xml_or_filename );
                              //Xslt_stylesheet             ( const BSTR xml_or_filename );
                               ~Xslt_stylesheet             ();

    static HRESULT              Create_instance             ( zschimmer::com::object_server::Session*, ptr<Object>*, const IID&, ptr<IUnknown>* result );  // Fr Proxy


    STDMETHODIMP_(ULONG)        AddRef                      ()                                      { return Idispatch_implementation::AddRef(); }
    STDMETHODIMP_(ULONG)        Release                     ()                                      { return Idispatch_implementation::Release(); }
    STDMETHODIMP                QueryInterface              ( const IID&, void** );

    // interface Ihas_java_class_name
    STDMETHODIMP            get_Java_class_name             ( BSTR* result )                        { return String_to_bstr( const_java_class_name(), result ); }
    STDMETHODIMP_(char*)  const_java_class_name             ()                                      { return (char*)"sos.spooler.Xslt_stylesheet"; }


    // interface Ixslt_stylesheet
    STDMETHODIMP                Close                       ();
    STDMETHODIMP                Load_xml                    ( BSTR, spooler_com::Ixslt_stylesheet** );
    STDMETHODIMP                Load_file                   ( BSTR, Ixslt_stylesheet** );
    STDMETHODIMP                Apply_xml                   ( BSTR, BSTR* );
  //STDMETHODIMP                Transform_xml_to_file       ( BSTR, BSTR );

  private:
    Fill_zero                  _zero_;
};

//-------------------------------------------------------------------------------------------------

} //namespace scheduler
} //namespace sos

#endif
