/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: async_event.h 5542 2008-01-27 15:27:19Z jz $

#ifndef __Z_ASYNC_EVENT_H
#define __Z_ASYNC_EVENT_H

#include "async.h"

//-------------------------------------------------------------------------------------------------

namespace zschimmer { 

struct Event_manager;

//-------------------------------------------------------------------------------------Socket_event
// Hat nicht so viel mit Sockets zu tun

#ifdef Z_WINDOWS
    typedef Event               Socket_event;
# else
    typedef Simple_event        Socket_event;
#endif

//-------------------------------------------------------------------------------------------------

struct Event_operation : Async_operation
{
                                Event_operation             ();// Event_manager* );
                               ~Event_operation             ();

    void                        add_to_event_manager        ( Event_manager* );
    void                        remove_from_event_manager   ();
    virtual Socket_event*       async_event                 ()                                      = 0;
    virtual bool                async_signaled_             ();

  private:
    Fill_zero                  _zero_;
    Event_manager*             _event_manager;
};

//------------------------------------------------------------------------------------Event_manager

struct Event_manager : Async_manager
{
                                Event_manager               ();
                               ~Event_manager               ();


    void                        get_events                  ( std::vector<Socket_event*>* );
    int                         wait                        ( double timeout_seconds );
    bool                        async_continue              ( double timeout = 0.0 )                  { return async_continue_selected( NULL, timeout ); }
    bool                        async_continue_selected     ( Operation_is_ok f, double timeout = 0.0 );


  protected:
    friend struct               Event_operation;

    // Benutze Event_operation::add_to_event_manager()!
    void                        add_event_operation         ( Event_operation* );
    void                        remove_event_operation      ( Event_operation* );

    bool                        async_continue_selected_    ( Operation_is_ok* );


    Fill_zero                  _zero_;

    typedef std::list< Event_operation* >  Event_operation_list;
    Event_operation_list       _event_operation_list;
    bool                       _event_operation_list_modified;
};

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer

#endif
