/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: java_jvm.cxx 6109 2010-06-03 15:29:33Z jz $

#include "zschimmer.h"
#include "java.h"
#include "z_com.h"

/*
    static_jvm liegt in einem eigenen Modul, damit java.cxx nicht eingebunden werden muss,
    nur weil irgendwo geprft wird, ob JavaVM* da ist (fr z_com.cxx beim Durchreichen der JavaVM).
*/

namespace zschimmer {
namespace javabridge {

//-------------------------------------------------------------------------------------------static

//JavaVM*                         Vm::static_foreign_jvm = NULL;
Mutex                           Vm::static_vm_mutex    ( "java_vm" );

//--------------------------------------------------------------------------------------Vm::set_jvm
/*
void Vm::set_jvm( JavaVM* jvm )
{
    if( com::static_com_context_ptr )
    {
        com::static_com_context_ptr->set_javavm( jvm );
    }
    else
    {
        Z_MUTEX( static_vm_mutex )
        {
    	    if( jvm )
    	    {
                if( static_foreign_jvm  &&  jvm != static_foreign_jvm )  throw_xc( "Z-JAVA-109" );

                static_foreign_jvm = jvm;
            }
            else
            {
                static_foreign_jvm = NULL;
            }
        }
    }
}
*/
//------------------------------------------------------------------------------------------Vm::jvm
/*
JavaVM* Vm::jvm()
{
    if( com::static_com_context_ptr )
    {
        return com::static_com_context_ptr->get_javavm();
    }
    else
    if( static_foreign_jvm )
    {
        return static_foreign_jvm;
    }
    else
    {
        return get_vm()->vm();
    }
}
*/
//--------------------------------------------------------------------------------------Vm::get_jvm

JavaVM* Vm::request_jvm()
{
    if( com::static_com_context_ptr )
    {
        return com::static_com_context_ptr->request_javavm();
    }
    else
    {
        Z_MUTEX( static_vm_mutex )
        {
            ptr<Vm> vm = get_vm( true );
            assert( +vm == static_vm );
            static_vm->AddRef();
        }

        return static_vm->vm();
    }
}

//----------------------------------------------------------------------------------Vm::release_jvm

void Vm::release_jvm( JavaVM* jvm )
{
    if( com::static_com_context_ptr )
    {
        com::static_com_context_ptr->release_javavm( jvm );
    }
    else
    {
        Z_MUTEX( static_vm_mutex )
        {
            int ref_count = static_vm->Release();
            if( ref_count == 0 )  static_vm = NULL;
        }
    }
}

//-------------------------------------------------------------------------------------------------


} //namespace javabridge
} //namespace zschimmer
