/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: string_list.h 5419 2007-12-06 14:15:42Z jz $

#ifndef __ZSCHIMMER_STRING_LIST_
#define __ZSCHIMMER_STRING_LIST_

#include "z_io.h"
//#include "immutable_string.h"


namespace zschimmer {

//--------------------------------------------------------------------------------------String_list

struct String_list
{
                                String_list             ()                                          : _read_offset(0) {}
                                String_list             ( const string& str )                       : _read_offset(0) { append( str ); }

    String_list&                operator =              ( const string& str )                       { clear(); append( str ); return *this; }

  //void                        append                  ( const string& str )                       { if( !str.empty() )  _list.push_back( str ); }
    void                        append                  ( const io::Char_sequence& seq )            { if( seq.length() > 0 )  _list.push_back( seq.to_string() ); }
    size_t                      length                  () const;
    string                      to_string               () const;
                                operator string         () const                                    { return to_string(); }
    bool                        is_empty                () const                                    { return _list.empty(); }
    void                        clear                   ()                                          { _list.clear();  _read_offset = 0; }

    io::Char_sequence           next_char_sequence      () const;
    io::Byte_sequence           next_byte_sequence      () const;
    void                        eat                     ( size_t );
    string                      string_eat              ( size_t );
    //Immutable_string            to_immutable_string     () const;
    //                            operator Immutable_string() const                                   { return to_immutable_string(); }

  private:
    std::list<string>          _list;
    size_t                     _read_offset;
};

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer

#endif
