/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: system_command.h 3546 2005-04-03 08:30:29Z jz $
// 2000 Joacim Zschimmer

#ifndef __SYSTEM_COMMAND_H
#define __SYSTEM_COMMAND_H

namespace zschimmer {

//-----------------------------------------------------------------------------------System_command

struct System_command
{
                            System_command              ()                                          : _zero_(this+1), _exit_code(-1), _throw_xc(true) {}
                            System_command              ( const string& cmd )                       : _zero_(this+1), _exit_code(-1), _throw_xc(true) { execute( cmd ); }
    
    void                    operator()                  ( const string& cmd )                       { execute( cmd ); }

    void                    set_throw                   ( bool throw_xc )                           { _throw_xc = throw_xc; }
    Xc*                     xc                          ()                                          { return _error? &_xc : 0; }
    int                     exit_code                   () const                                    { return _exit_code; }
    void                    execute                     ( const string& cmd );
  //int                     execute_with_exit_code      ( const string& cmd );

    const string&           stdout_text                 ()                                          { return _stdout_text; }
    const string&           stderr_text                 ()                                          { return _stderr_text; }
    

    Fill_zero              _zero_;
    bool                   _throw_xc;
    bool                   _error;
    Xc                     _xc;
    int                    _exit_code;
    string                 _stdout_text;
    string                 _stderr_text;
};

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer

#endif
