/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: xml_end_finder.h 5419 2007-12-06 14:15:42Z jz $

#ifndef __XML_END_FINDER_H
#define __XML_END_FINDER_H

namespace zschimmer {

//-----------------------------------------------------------------------------------Xml_end_finder

struct Xml_end_finder
{
    // Findet das Ende eines XML-Dokuments

    enum Tok 
    { 
        cdata_tok, 
        comment_tok,
        max_tok 
    };


    struct Tok_entry
    {
                                Tok_entry                   ()                          : _index(0),_active(false) {}

        void                    reset                       ()                          { _index = 0; _active = false; }
        bool                    step_begin                  ( char );
        void                    step_end                    ( char );

        int                    _index;
        bool                   _active;
        const char*            _begin;
        const char*            _end;
    };


                                Xml_end_finder              ();

    bool                        is_complete                 ( const char* p, int length );
    bool                        is_complete                 ()                          { return _xml_is_complete; }

    Fill_zero                  _zero_;

    int                        _open_elements;              // Anzahl der offenen Elemente (ohne <?..?> und <!..>)
    bool                       _at_start_tag;               // Letztes Zeichen war '<'
    bool                       _in_special_tag;             // <?, <!
    bool                       _in_tag;                 
    bool                       _in_end_tag;             
    bool                       _at_begin;
    bool                       _is_xml;                     // Ist es XML?
    bool                       _xml_is_complete;
    char                       _last_char;
    Tok_entry                  _tok [ max_tok ];
};

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer

#endif
