/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: z_windows_mutex.h 3546 2005-04-03 08:30:29Z jz $

#ifndef ZSCHIMMER_Z_WINDOWS_MUTEX_H
#define ZSCHIMMER_Z_WINDOWS_MUTEX_H

#ifdef Z_WINDOWS

#include "mutex_base.h"

namespace zschimmer {
namespace windows {

//--------------------------------------------------------------------------------------------------

typedef CRITICAL_SECTION        System_mutex;

inline void                     enter_mutex                 ( System_mutex* m )                     { EnterCriticalSection( m ); }
inline void                     leave_mutex                 ( System_mutex* m )                     { LeaveCriticalSection( m ); }

//------------------------------------------------------------------------------------windows::Mutex
// AUFBAU NICHT NDERN, wird mit zur Laufzeit nachgeladenem Modul ausgetauscht!

struct Mutex : Mutex_base
{
                                Mutex                       ( const string& name = "", Kind kind = kind_recursive ) : Mutex_base(name,kind) { InitializeCriticalSection( &_system_mutex ); }
                               ~Mutex                       ()                                      { DeleteCriticalSection( &_system_mutex ); }

    void                        enter                       () throw()                              { enter_mutex( &_system_mutex ); }
    bool                        try_enter                   ();
    void                        leave                       () throw()                              { leave_mutex( &_system_mutex ); }
    Thread_id                   locking_thread_id           ();

    CRITICAL_SECTION           _system_mutex;
};

//-------------------------------------------------------------------------------------------------

} //namespace windows
} //namespace zschimmer

#endif
#endif
